:START
cls
@echo off
Echo. 
Echo                        **********************************
Echo                        * Solaris17s GPU Autoflasher 1.3 *
Echo                        **********************************
Echo.
Echo Brought to you by: Solaris17 [TPU]
Echo.
Echo This script and its Author(s) offer no warranty expressed or implied.
Echo.
Echo Updates for this script are hosted on Techpowerup.com
Echo.
Echo Please make sure the BIOS file you would like flashed is named 'flash.rom'
Echo.
Echo Please make sure there is only ONE (1) GPU in the system! (First PCI-E slot)
Echo.
Echo If flashing freezes hit CTRL+C to break operation! DO NOT REBOOT!
Echo.
pause


:menu
cls
Echo.
Echo Hi there, Which GPU do you own?
Echo.
Echo 1 = AMD/ATI
Echo.
Echo 2 = Nvidia
Echo.
Echo 3 = Find out for me
Echo.
Echo 4 = Backup All GPUs
Echo.
Echo 5 = This is crazy! (Shutdown)
CHOICE /C:12345 /n
IF ERRORLEVEL 5 goto EOF
IF ERRORLEVEL 4 goto Backup
IF ERRORLEVEL 3 goto detect
IF ERRORLEVEL 2 goto NFLASH
IF ERRORLEVEL 1 goto AMDFLASH
goto menu


:detect
cls
Echo.
Echo Checking for ATI GPUs in the system...
atiflash.exe -i
Echo.
Echo Checking for Nvidia GPUs in the system...
nvflash --check
Echo.
Echo Ok! These are the results! Now just press the corresponding number!
Echo.
Echo 1 = AMD/ATI
Echo.
Echo 2 = Nvidia
Echo.
Echo 3 = It didnt find one!
Echo.
CHOICE /C:123 /n
IF ERRORLEVEL 3 goto ohno
IF ERRORLEVEL 2 goto NFLASH
IF ERRORLEVEL 1 goto AMDFLASH
goto detect

:AMDFLASH
cls
Echo.
Echo Backing up the GPU now... (AMDGPU.rom)
atiflash -s 0 AMDGPU.rom
Echo.
Echo Complete!
Echo. Flashing the new bios to the GPU!
atiflash -unlockrom 0
Echo.
atiflash -f -p 0 flash.rom
Echo.
pause
goto acheck

:NFLASH
cls
Echo.
Echo Backing up the GPU now...(NVGPU.rom)
nvflash -b NVGPU.rom
Echo.
Echo Complete!
Echo. Flashing the new bios to the GPU!
nvflash --protectoff
Echo.
nvflash -4 -5 -6 -A flash.rom
Echo.
pause
goto ncheck

:Backup
cls
Echo.
echo Performing backup of all detected GPUs
Echo.
nvflash -b NVGPU.rom
Echo.
atiflash -s 0 AMDGPU.rom
Echo.
Echo Complete!!
Echo.
goto menu

:acheck
cls
Echo.
Echo If your flash was successful continue otherwise enter recovery.
Echo.
Echo 1 = Continue
Echo.
Echo 2 = Recovery
Echo.
CHOICE /C:12 /n
IF ERRORLEVEL 2 goto arecover
IF ERRORLEVEL 1 goto complete
goto acheck

:ncheck
cls
Echo.
Echo If your flash was successful continue otherwise enter recovery.
Echo.
Echo 1 = Continue
Echo.
Echo 2 = Recovery
Echo.
CHOICE /C:12 /n
IF ERRORLEVEL 2 goto nrecover
IF ERRORLEVEL 1 goto complete
goto ncheck

:arecover
cls
Echo.
Echo Welcome to recovery mode! Now attempting to flash back!
Echo.
Echo. Flashing recovery bios to the GPU!
atiflash -unlockrom 0
Echo.
atiflash -f -p 0 AMDGPU.rom
Echo.
pause
goto acheck

:nrecover
cls
Echo.
Echo Welcome to recovery mode! Now attempting to flash back!
Echo.
Echo. Flashing recovery bios to the GPU!
nvflash --protectoff
Echo.
nvflash -4 -5 -6 -A NVGPU.rom
Echo.
pause
goto ncheck

:ohno
cls
Echo.
Echo OOPS! We couldnt detect any GPUs in this system!
Echo.
Echo If you think this is an error you can try to explain it to the author!
Echo.
Echo http://www.techpowerup.com
Echo.
Echo Remember to explain in detail whats going on as accurately and in as much detail as possible!
Echo.
Pause
goto EOF

:complete
cls
Echo.
Echo Shutting down system! Please remove USB drive from computer before rebooting!
Echo.
pause
goto EOF

:EOF
shutdown -s 0